
--Readability == win
local RUNETYPEC_BLOOD = 1;
local RUNETYPEC_UNHOLY = 2;
local RUNETYPEC_FROST = 3;
local RUNETYPEC_CHROMATIC = 4;

local runeY = {
	[1] = -8,
	[2] = -18,
	[3] = -28,
	[4] = -38,
	[5] = -48,
	[6] = -58,
}
local runeX = 8;

function RuneButtonC_OnLoad (self)
	RuneFrameC_AddRune(RuneFrameC, self);
	
	self.rune = getglobal(self:GetName().."Rune");
	self.fill = getglobal(self:GetName().."Fill");

	DEFAULT_CHAT_FRAME:AddMessage( self:GetTop() );
	DEFAULT_CHAT_FRAME:AddMessage( self:GetLeft() );
	DEFAULT_CHAT_FRAME:AddMessage( self:GetID() );

	RuneButtonC_Update(self);

	self:SetScript("OnUpdate", RuneButtonC_OnUpdate);
end

function RuneButtonC_OnUpdate (self, elapsed)

	local start, duration, r = GetRuneCooldown(self:GetID());

	if (r) then
		self:SetPoint("TOPLEFT", "RuneFrameC", "TOPLEFT", runeX, runeY[self:GetID()] );
	else
		local remain = (duration - GetTime() + start) / duration;
		if ( remain < 0) then 
			self:SetPoint("TOPLEFT", "RuneFrameC", "TOPLEFT", runeX, runeY[self:GetID()] );
		else
			self:SetPoint("TOPLEFT", "RuneFrameC", "TOPLEFT", runeX + remain*(RuneFrameC:GetWidth()-38), runeY[self:GetID()]);
		end
	end
end

function RuneButtonC_Update (self, rune)

	rune = rune or self:GetID();
	
	local runeType = GetRuneType(rune);

	if (runeType == RUNETYPEC_BLOOD) then
		self.rune:SetTexture( "Interface\\AddOns\\RuneCC\\textures\\Frost-red.tga" );
	elseif (runeType == RUNETYPEC_UNHOLY) then
		self.rune:SetTexture( "Interface\\AddOns\\RuneCC\\textures\\Frost-green.tga");
	elseif (runeType == RUNETYPEC_FROST) then
		self.rune:SetTexture( "Interface\\AddOns\\RuneCC\\textures\\Frost-blue.tga" );
	elseif (runeType == RUNETYPEC_CHROMATIC) then
		self.rune:SetTexture( "Interface\\AddOns\\RuneCC\\textures\\Frost.tga" );
	end
end

function RuneFrameC_OnLoad (self)

	-- Disable rune frame if not a death knight.
	local _, class = UnitClass("player");
	
	if ( class ~= "DEATHKNIGHT" ) then
		self:Hide();
	end
	
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	self:SetScript("OnEvent", RuneFrameC_OnEvent);
	
	self.runes = {};
end

function RuneFrameC_OnEvent (self, event, ...)
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		for rune in next, self.runes do
			RuneButtonC_Update(self.runes[rune], rune);
		end
	end
end

function RuneFrameC_AddRune (runeFrameC, rune)
	tinsert(runeFrameC.runes, rune);
end
